/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.blogspot.adepranaya.mavenproject.java.views;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.SwingWorker;

/**
 *
 * @author depran
 */
public class UploadImage extends javax.swing.JFrame {

    File sourceFile;
    File destFile;
    private ImageIcon ii;

    /**
     * Creates new form UploadImage
     */
    public UploadImage() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        chooseImgBtn = new javax.swing.JButton();
        dirFileTextField = new javax.swing.JTextField();
        saveBtn = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Simple Upload File");

        chooseImgBtn.setText("choose image");
        chooseImgBtn.setFocusPainted(false);
        chooseImgBtn.setFocusable(false);
        chooseImgBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chooseImgBtnActionPerformed(evt);
            }
        });

        dirFileTextField.setEnabled(false);

        saveBtn.setText("save");
        saveBtn.setFocusPainted(false);
        saveBtn.setFocusable(false);
        saveBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveBtnActionPerformed(evt);
            }
        });

        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/icons8_Instagram_20px.png"))); // NOI18N
        jLabel2.setText("@depran7");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(chooseImgBtn)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(dirFileTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(saveBtn))
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addContainerGap(87, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(chooseImgBtn)
                    .addComponent(dirFileTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(saveBtn))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 216, Short.MAX_VALUE)
                .addComponent(jLabel2)
                .addContainerGap())
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void chooseImgBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chooseImgBtnActionPerformed
        JFileChooser chooser = new JFileChooser();
        chooser.showOpenDialog(null);
        sourceFile = chooser.getSelectedFile();
        String filename = sourceFile.getAbsolutePath();
        
        if (sourceFile == null) {
            return;
        }
        dirFileTextField.setText(filename);

        /*akan lebih baik diverifikasi terlebih dahulu extention filenya .jpg .png atau sejenisnya 
        sebelum di eksekusi lebih lanjut*/
        SwingWorker sw = new SwingWorker() {
            @Override
            protected Object doInBackground() throws Exception {
//                Thread.sleep(5000);//simulate large image takes long to load
                ii = new ImageIcon(scaleImage(120, 120, ImageIO.read(new File(sourceFile.getAbsolutePath()))));
                return null;
            }

            @Override
            protected void done() {
                super.done();
                jLabel1.setIcon(ii);
            }
        };
        sw.execute();
    }//GEN-LAST:event_chooseImgBtnActionPerformed
    private void saveBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveBtnActionPerformed
        //mendapatkan lokasi directory project
        Path currentRelativePath = Paths.get("");

        //folder tujuan atau target
        Path targetDirectory = Paths.get(currentRelativePath.toAbsolutePath().toString()
                + "\\src\\main\\resources\\img\\"
                + sourceFile.getName());
        String targetDirS = targetDirectory.toAbsolutePath().toString();
        System.out.println("target: " + targetDirS);

        //folder asal atau source
        Path sourceDirectory = Paths.get(sourceFile.toString());
        String sourceDirS = sourceDirectory.toAbsolutePath().toString();
        System.out.println("source: " + sourceDirS);
        destFile = new File(targetDirS);
        if (destFile.exists()) {
            int response = JOptionPane.showConfirmDialog(null,
                    "Overwrite existing file?", "Confirm Overwrite",
                    JOptionPane.OK_CANCEL_OPTION,
                    JOptionPane.QUESTION_MESSAGE);
            if (response == JOptionPane.CANCEL_OPTION) {
                JOptionPane.showMessageDialog(null, "Canceled");
            } else {
                uploadFile(sourceDirectory, targetDirectory);
            }
        } else {
            uploadFile(sourceDirectory, targetDirectory);
        }

    }//GEN-LAST:event_saveBtnActionPerformed

    public void uploadFile(Path sourceDirectory, Path targetDirectory) {
        try {
            //code ini hanya untuk copy data sumber ke tujuan
            Files.copy(sourceDirectory, targetDirectory);
            /*tambahakan kode disini untuk upload nama file ke db sebelum pesan success ditampilkan*/
            JOptionPane.showMessageDialog(null, "success");
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(null, "success");
        }
    }

    public static BufferedImage scaleImage(int w, int h, BufferedImage img) throws Exception {
        BufferedImage bi;
        bi = new BufferedImage(w, h, BufferedImage.TRANSLUCENT);
        Graphics2D g2d = (Graphics2D) bi.createGraphics();
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g2d.addRenderingHints(new RenderingHints(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY));
        g2d.drawImage(img, 0, 0, w, h, null);
        g2d.dispose();
        return bi;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton chooseImgBtn;
    private javax.swing.JTextField dirFileTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JButton saveBtn;
    // End of variables declaration//GEN-END:variables
}
